package org.hornetq.jms.example;

import java.util.Random;

import javax.jms.Message;

import org.hornetq.jms.client.HornetQTextMessage;

class Consumer extends Thread {

	/**
	 * 
	 */
	private final int consumerId;
	private final NoConsumerBufferingExample caller;
	private boolean isFirstMessage = true;

	public Consumer(int consumerId, NoConsumerBufferingExample NoConsumerBufferingExample) {
		this.consumerId = consumerId;
		this.caller = NoConsumerBufferingExample;
	}

	@Override
	public void run() {
		caller.printMessege(consumerId + "\t: Starting Consumer");

		// Connect to the server
		MessagingHandler messagingHandler = new MessagingHandler("localhost", "5445");

		long numberOfEmptyMessagesSinceLastMission = 0;
		Random random = new Random();
		long range = (long) caller.maxDelay - (long) caller.minDelay + 1;

		// run until stopped
		try {
			do {
				try {
					Message message = null;
					try {

						message = messagingHandler.getMessage();
					} catch (Exception e1) {

						caller.printError(consumerId + "\t: Refreshing Connections");

						messagingHandler.refreshConnection();
					}

					// if there was no message to handle
					if (message == null) {
						try {

							numberOfEmptyMessagesSinceLastMission++;
							caller.printError(consumerId
									+ "\t: No message received; Num of empty messages "
									+ numberOfEmptyMessagesSinceLastMission);

							// sleep for 10 seconds and try again
							Thread.sleep(10000);

						} catch (InterruptedException e) {
							e.printStackTrace();
							break;
						}
					} else {

						// handle the message

						// Sleep random time to cause delay in handling
						try {

							long fraction = (long) (range * random.nextDouble());
							int randomNumber = (int) (fraction + caller.minDelay);

							String text = ((HornetQTextMessage) message).getText();
							caller.printMessege(consumerId + "\t: Will take " + randomNumber
									+ "\tseconds to handle message: " + text);

							if (!isFirstMessage) {

								caller.addMessage(text);
							} else {
								isFirstMessage = false;
							}

							Thread.sleep(randomNumber * 1000);
						} catch (InterruptedException e) {
							e.printStackTrace();
							break;
						}

						messagingHandler.commit();
						numberOfEmptyMessagesSinceLastMission = 0;
					}

					// check if we need to refresh the connection
					if (numberOfEmptyMessagesSinceLastMission > 60) {

						caller.printError(consumerId
								+ "\t: ; Didn't get any message in the last 10 minutes - refreshing connections");

						numberOfEmptyMessagesSinceLastMission = 0;

						messagingHandler.refreshConnection();
					}
				} catch (Exception e2) {

					e2.printStackTrace();
				}
			} while (caller.isRunning());
		} catch (Exception e) {
			e.printStackTrace();
		}

		messagingHandler.cleanConnections();
	}
}